<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfJP_HotelAdditionalElement1 ArrayType
 * @subpackage Arrays
 */
class ArrayOfJP_HotelAdditionalElement1 extends AbstractStructArrayBase
{
    /**
     * The HotelOffer
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\JP_HotelAdditionalElement[]
     */
    public $HotelOffer;
    /**
     * Constructor method for ArrayOfJP_HotelAdditionalElement1
     * @uses ArrayOfJP_HotelAdditionalElement1::setHotelOffer()
     * @param \StructType\JP_HotelAdditionalElement[] $hotelOffer
     */
    public function __construct(array $hotelOffer = array())
    {
        $this
            ->setHotelOffer($hotelOffer);
    }
    /**
     * Get HotelOffer value
     * @return \StructType\JP_HotelAdditionalElement[]|null
     */
    public function getHotelOffer()
    {
        return $this->HotelOffer;
    }
    /**
     * Set HotelOffer value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_HotelAdditionalElement[] $hotelOffer
     * @return \ArrayType\ArrayOfJP_HotelAdditionalElement1
     */
    public function setHotelOffer(array $hotelOffer = array())
    {
        foreach ($hotelOffer as $arrayOfJP_HotelAdditionalElement1HotelOfferItem) {
            // validation for constraint: itemType
            if (!$arrayOfJP_HotelAdditionalElement1HotelOfferItem instanceof \StructType\JP_HotelAdditionalElement) {
                throw new \InvalidArgumentException(sprintf('The HotelOffer property can only contain items of \StructType\JP_HotelAdditionalElement, "%s" given', is_object($arrayOfJP_HotelAdditionalElement1HotelOfferItem) ? get_class($arrayOfJP_HotelAdditionalElement1HotelOfferItem) : gettype($arrayOfJP_HotelAdditionalElement1HotelOfferItem)), __LINE__);
            }
        }
        $this->HotelOffer = $hotelOffer;
        return $this;
    }
    /**
     * Add item to HotelOffer value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_HotelAdditionalElement $item
     * @return \ArrayType\ArrayOfJP_HotelAdditionalElement1
     */
    public function addToHotelOffer(\StructType\JP_HotelAdditionalElement $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\JP_HotelAdditionalElement) {
            throw new \InvalidArgumentException(sprintf('The HotelOffer property can only contain items of \StructType\JP_HotelAdditionalElement, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->HotelOffer[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\JP_HotelAdditionalElement|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\JP_HotelAdditionalElement|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\JP_HotelAdditionalElement|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\JP_HotelAdditionalElement|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\JP_HotelAdditionalElement|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string HotelOffer
     */
    public function getAttributeName()
    {
        return 'HotelOffer';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfJP_HotelAdditionalElement1
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
